#include "cellspace.h"

cellspace::cellspace(int width, int height, double D, double dx, double dy, double k):
netExec(NULL)
{
	cell::width = width;
	cell::height = height;
	cell::D = D;
	cell::dx = dx;
	cell::dy = dy;
	cell::k = k;
	cell::create_space();
	space = new cell*[width];
	for (int i = 0; i < height; i++)
		space[i] = new cell[height];
	for (int i = 0; i < width; i++)
		for (int j = 0; j < height; j++)
			space[i][j].set_pos(i,j);
}
			
void cellspace::route(const PortValue& pv, devs* src, adevs_bag<EventReceiver>& r)
{
	cell* c = (cell*)src;
	int x = c->get_x();
	int y = c->get_y();
	if (x > 0)
		r.add(EventReceiver(&space[x-1][y],cell::in));
	else
		r.add(EventReceiver(&space[cell::width-1][y],cell::in));
	if (y > 0)
		r.add(EventReceiver(&space[x][y-1],cell::in));
	else
		r.add(EventReceiver(&space[x][cell::height-1],cell::in));
	r.add(EventReceiver(&space[(x+1)%cell::width][y],cell::in));
	r.add(EventReceiver(&space[x][(y+1)%cell::height],cell::in));
}

void cellspace::getComponents(adevs_set<devs*>& c)
{
	for (int i = 0; i < cell::width; i++)
		for (int j = 0; j < cell::height; j++)
			c.add(&space[i][j]);
}

void cellspace::report(ofstream& stream)
{
	for (int i = 0; i < cell::width; i++)
	{
		for (int j = 0; j < cell::height; j++)
		{
			space[i][j].report(stream);
		}
		stream << endl;
	}
}

cellspace::~cellspace()
{
	for (int i = 0; i < cell::height; i++)
		delete [] space[i];
	delete [] space;
	cell::delete_space();
}
