#include <adevs.h>
#include <iostream>
#ifndef __counter_h_
#define __counter_h_

class counter: public atomic 
{
	public:
		static const port_t in;

		counter::counter():atomic(),count(0){}
		counter::counter(const counter& src):atomic(src),count(src.count){}
		object* clone() const { return new counter(*this); }
		void init()
		{
			count = 0;
			passivate();
		}
		void delta_int() 
		{ 
			passivate(); 
		}
		void delta_ext(stime_t t, const adevs_bag<PortValue>& x) 
		{
			for (int i = 0; i < x.getSize(); i++)
			{
				assert(x.get(i).port == in);
			}
			count += x.getSize();
			std::cout << "Count is " << count << " @ " << timeCurrent() << std::endl;
			passivate(); 
		} 
		void delta_conf(const adevs_bag<PortValue>& x)
		{
			assert(false);
		}
		void output_func(adevs_bag<PortValue>& y)
		{
			assert(false);
		}
		void gc_output(adevs_bag<PortValue>& g)
		{
			assert(g.getSize() == 0);
		}
		~counter(){}
	private:	
		int count;
};

const port_t counter::in(0);

#endif
